// code by Michael Angeletti

var $j = jQuery.noConflict();
var cart = {};

$j('document').ready(function(){
	
	// Runtime
	
	capture_get_parameters();
	complete_form_fields();
	update_total();
	
	// Events
	
	$j('.edit_shipping a').click(function(event){
		event.preventDefault();
		$j('.shippingaddress').toggle(250);
	});
	
	$j('form.checkout').submit(function(event){
		if(!form_is_valid())
		{
			event.preventDefault();
		}
	});
	
	$j('[name=add]').each(function(){
		try
		{
			if(this.checked == true)
			{
				$j('[rel=check_' + $j(this).attr('value') + ']').addClass('checked');
			}
		}
		catch(e)
		{
			//
		}
	});
	
	$j('[name=add]').click(function(){
		try
		{
			$j('[rel^=check_]').removeClass('checked');
			$j('[rel=check_' + $j(this).attr('value') + ']').click();
		}
		catch(e)
		{
			//
		}
	});
	
	$j('[rel^=check_]').click(function(){
		try
		{
			$j('[rel^=check_]').removeClass('checked');
			$j('[value=' + $j(this).attr('rel').slice(6) + ']')[0].checked = true;
			$j(this).toggleClass('checked');
		}
		catch(e)
		{
			//
		}
	});
	
	// Functions
	
	function update_total()
	{
		var total = 0;
		$j('[name^=add]:checked').each(function(){
			total += Number($j(this).attr('title').replace('$', ''));
		});
		$j('[name^=add]:hidden').each(function(){
			total += Number($j(this).attr('title').replace('$', ''));
		});
		total = total.toFixed(2);
		$j('[title=total]').html('$' + total);
	}
	
	function billing_same_as_shipping()
	{
		if($j('[name=billingsameasshipping]:checked').val() == 'true')
		{
			$j('.billingaddress').hide(250);
			$j('.billing :input').attr('disabled', 'disabled');
		}
		else
		{
			$j('.billing :input').removeAttr('disabled');
			$j('.billingaddress').show(250);
		}
	}
	
	function capture_get_parameters()
	{
		cart.shippingvalues = [];
		cart.shippingvalues.push({value: ($j.url.param('shippingfirstname')) ? unescape($j.url.param('shippingfirstname').replace(/\+/g, ' ')):'', name: 'shippingfirstname', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippinglastname')) ? unescape($j.url.param('shippinglastname').replace(/\+/g, ' ')):'', name: 'shippinglastname', required: true});
		cart.shippingvalues.push({value: ($j.url.param('email')) ? unescape($j.url.param('email').replace(/\+/g, ' ')):'', name: 'email', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingaddress1')) ? unescape($j.url.param('shippingaddress1').replace(/\+/g, ' ')):'', name: 'shippingaddress1', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingaddress2')) ? unescape($j.url.param('shippingaddress2').replace(/\+/g, ' ')):'', name: 'shippingaddress2', required: false});
		cart.shippingvalues.push({value: ($j.url.param('shippingcity')) ? unescape($j.url.param('shippingcity').replace(/\+/g, ' ')):'', name: 'shippingcity', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingstate')) ? unescape($j.url.param('shippingstate').replace(/\+/g, ' ')):'', name: 'shippingstate', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingcountry')) ? unescape($j.url.param('shippingcountry').replace(/\+/g, ' ')):'', name: 'shippingcountry', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingpostalcode')) ? unescape($j.url.param('shippingpostalcode').replace(/\+/g, ' ')):'', name: 'shippingpostalcode', required: true});
		cart.shippingvalues.push({value: ($j.url.param('shippingdayphone')) ? unescape($j.url.param('shippingdayphone').replace(/\+/g, ' ')):'', name: 'shippingdayphone', required: false});
		$j.each(cart.shippingvalues, function(){
			if(this.name == 'shippingcountry'){}
		});
		
		var show_shipping_fields = false;
		
		$j.each(cart.shippingvalues, function(){
			if(this.required && !this.value)
			{
				show_shipping_fields = true;
				return;
			}
		});
		
		if(show_shipping_fields)
		{
			//$j('.shippingaddress').show();
		}
	}
	
	function form_is_valid()
	{
		var errors = [];
		var show_shipping = null;
		$j('.shippingaddress [title^=required:]').each(function(){
			if(!$j(this).val())
			{
				show_shipping = true;
				errors.push($j(this).attr('title').slice(10));
			}
		});
		if($j('[name=billingsameasshipping]:checked').val() == 'false')
		{
			$j('.billingaddress [title^=required:]').each(function(){
				if(!$j(this).val())
				{
					errors.push($j(this).attr('title').slice(10));
				}
			});
		}
		$j('.paymentinfo [title^=required:]').each(function(){
			if(!$j(this).val())
			{
				errors.push($j(this).attr('title').slice(10));
			}
		});
		if(errors.length > 0)
		{
			display_errors(errors);
			if(show_shipping)
			{
				$j('.shippingaddress').show(250);
			}
			else
			{
				$j('.shippingaddress').hide(250);
			}
			return false;
		}
		else
		{
			return true;
		}
	}
	
	function display_errors(errors)
	{
		$j('.errors ol').html('');
		$j.each(errors, function(){
			$j('.errors ol').append('<li>' + this + '</li>');
		});
		$j('.errors').show(250);
		$j('html,body').animate({scrollTop: $j('.errors').offset().top - 10}, 1000);
	}
	
	function complete_form_fields()
	{
		$j.each(cart.shippingvalues, function(){
			if(this.value)
			{
				$j('[name=' + this.name + ']').val(this.value);
			}
		});
	}
});