// jQuery Compatibility Method
var $j = jQuery.noConflict();
var formExpanded = false;

$j("document").ready(function(){


	// hide order form
	
	$j('.errors').hide();
	$j('.shell').hide();
	$j('.footer').hide();
	
	
	
	// show order form and hide action
	
	$j('.action a').click(function(event){
		event.preventDefault();
		$j('.action').hide(250);
		$j('.shell').show(250);
		$j('.footer').show(250);
	});
	
	
	
	// display only the next two fields
	
	var firstDL = $j('#order dl:first');
	var secondDL = firstDL.next();
	var lastShownDL = secondDL.next();
	
	$j('#order dl').hide();
	firstDL.show();
	secondDL.show();
	lastShownDL.show();
	
	$j('#order dl dd input').blur(function(){
		showNextDL($j(this));
	});
	
	$j('#order dl dd select').blur(function(){
		showNextDL($j(this));
	});




	cart = getCartInstance();
	inputFormValues();
	addItemsToCart();
	setShippingMethod();
	displayQueryErrors();
	
	
	cart.paymentMethod = PAYMENT_METHOD_CREDIT_CARD;
	cart.screenBrandingThemeCode = screenBrandingThemeCode;
		
		
	if(cart.shipToFirstName)
	{
		$j('.action').hide();
		$j('.shell').show();
		$j('.footer').show();
		$j('#order dl').show();
	}
	
	$j('#FinalizeOrder').click(function(event){
		event.preventDefault();
		$j('#FinalizeOrder').attr('class', 'loading');
		$j('#FinalizeOrder').attr('disabled', 'disabled');
		$j('.errors').hide(250);
		updateShippingAndBillingInfo();
		applyAutoResponders();
		attemptCompleteOrder();
	});
	
	
	
	
	
	
	
	
	// Trigger background updating of cart for capturing abandons
	
	$j('.background_update').blur(function(){
		updateLocalShippingAndBillingInfo();
		triggerBackgroundUpdateCart();
	});
	
	$j('.background_update').keypress(function(){
		updateLocalShippingAndBillingInfo();
		triggerBackgroundUpdateCart();
	});
	
	
	
	
	
	
	
	
	// Error Handling
	
	function handleError(message, error)
	{
		try
		{
			var logMessage = '';
			
			if(message)
			{
				logMessage += String(message);
				logMessage += ':\n';
			}
			
			if(error)
			{
				logMessage += String(error);
				logMessage += '\nFile:';
				logMessage += String(error.fileName);
				logMessage += '\nLine:';
				logMessage += String(error.lineNumber);
			}
			
			loggError(String(logMessage));
		}
		catch(e)
		{
			alert('There was a small error, please refresh your page.' + e);
		}
	}
	
	
	
	
	
	
	
	
	// Set shipping and billing address, phone and email
	
	function updateShippingAndBillingInfo()
	{
		try
		{
			updateLocalShippingAndBillingInfo();
			
			updateCart();
		}
		catch(e)
		{
			handleError('updateShippingAndBillingInfo()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Local update for shipping/billing information
	
	function updateLocalShippingAndBillingInfo()
	{
		try
		{
			cart.shipToFirstName	=	$j('#ShippingFirstName').val();
			cart.shipToLastName		=	$j('#ShippingLastName').val();
			cart.shipToPhone		=	$j('#ShippingDayPhone').val();
			cart.shipToAddress1		=	$j('#ShippingAddress1').val();
			cart.shipToCity			=	$j('#ShippingCity').val();
			cart.shipToState		=	$j('#ShippingState').val();
			cart.shipToPostalCode	=	$j('#ShippingPostalCode').val();
			cart.shipToCountry		=	$j('#ShippingCountry').val();
			
			cart.email				=	$j('#email').val();
			
			cart.billToFirstName	=	cart.shipToFirstName;
			cart.billToLastName		=	cart.shipToLastName;
			cart.billToDayPhone		=	cart.shipToPhone;
			cart.billToAddress1		=	cart.shipToAddress1;
			cart.billToCity			=	cart.shipToCity;
			cart.billToState		=	cart.shipToState;
			cart.billToPostalCode	=	cart.shipToPostalCode;
			cart.billToCountry		=	cart.shipToCountry;
			
			cart.creditCardType					=	$j('#CreditCardType').val();
			cart.creditCardNumber				=	$j('#CreditCardNumber').val();
			cart.creditCardExpirationMonth		=	Number($j('#CreditCardExpMonth').val());
			cart.creditCardExpirationYear		=	Number($j('#CreditCardExpYear').val());
			cart.creditCardVerificationNumber	=	$j('#CreditCardVerificationNumber').val();
		}
		catch(e)
		{
			handleError('updateLocalShippingAndBillingInfo()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Input form values from cart instance
	
	function inputFormValues()
	{
		try
		{
			updateFormFields();
			
			$j('#ShippingFirstName').val(cart.shipToFirstName);
			$j('#ShippingLastName').val(cart.shipToLastName);
			$j('#ShippingDayPhone').val(cart.shipToPhone);
			$j('#ShippingAddress1').val(cart.shipToAddress1);
			$j('#ShippingCity').val(cart.shipToCity);
			$j('#ShippingState').val(cart.shipToState);
			$j('#ShippingPostalCode').val(cart.shipToPostalCode);
			
			$j('#email').val(cart.email);
			
			$j('#CreditCardType').val(cart.creditCardType);
			$j('#CreditCardNumber').val(cart.creditCardNumber);
			$j('#CreditCardExpMonth').val(cart.creditCardExpirationMonth);
			$j('#CreditCardExpYear').val(cart.creditCardExpirationYear);
			$j('#CreditCardVerificationNumber').val(cart.creditCardVerificationNumber);
			
			if($j.cookie('TermsAgreement') && $j.cookie('TermsAgreement') == 'yes')
			{
				$j('#TermsAgreement').attr('checked', 'checked');
			}
		}
		catch(e)
		{
			handleError('inputFormValues()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Show next DL
	
	var currentDL = lastShownDL;
	
	function showNextDL(blurredInput)
	{
		try
		{
			blurredInput.parent().parent().next().show(250);
			blurredInput.parent().parent().next().next().show(250);
			blurredInput.parent().parent().next().next().next().show(250);
		}
		catch(e)
		{
			handleError('showNextDL()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Update form fields to reflect card types accepted, etc.
	
	function updateFormFields()
	{
		try
		{
			/*
			var creditCardTypeSelectHtml = '<option selected="selected"></option>';
			
			for(i = 0; i < cart.creditCardTypes.length; i ++)
			{
				creditCardTypeSelectHtml += '<option>' + cart.creditCardTypes[i] + '</option>';
			}
			
			$j('#CreditCardType').html(creditCardTypeSelectHtml);
			*/
		}
		catch(e)
		{
			handleError('updateFormFields()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Set shipping method to default method
	
	function setShippingMethod()
	{
		try
		{
			if(cart.needShipping)
			{
				var shippingEstimates = estimateShipping();
				
				if(shippingEstimates != null && shippingEstimates.length > 0)
				{
					cart.shippingMethod = shippingEstimates[0].name;
					cart.shippingHandling = shippingEstimates[0].cost;
				}
			}
			
		}
		catch(e)
		{
			handleError('setShippingMethod()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Auto reponders (based on GetResponseAdd input currently)
	
	function applyAutoResponders()
	{
		try
		{
			var responder = false;
			var responderArray = false;
			
			for(i = 0; i < AUTO_RESPONDER_NAMES.length; i ++)
			{
				responder = false;
				responderArray = false;
				responder = $j('[name=' + AUTO_RESPONDER_NAMES[i] + 'Add]').val();
				if(responder)
				{
					responderArray = responder.split(",");
					var errors = subscribeToAutoResponder(AUTO_RESPONDER_NAMES[i], responderArray);
					if(errors != null && errors.length > 0)
					{
						displayCartErrors(errors);
					}
				}
			}
		}
		catch(e)
		{
			handleError('applyAutoResponders()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Attempt to place order
	
	function attemptCompleteOrder()
	{
		try
		{
			var errors = doFullValidation();
			
			if(errors != null && errors.length > 0)
			{
				displayCartErrors(errors);
			}
			else
			{
				completeOrder();
			}
		}
		catch(e)
		{
			handleError('attemptCompleteOrder()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Wrapper for validateAll()
	
	function doFullValidation()
	{
		try
		{
			// Default validation rules
			
			var errors = validateAll();
			
			if(errors == null || errors == false)
			{
				errors = new Array();
			}
			
			// Custom validation rules
			
			try
			{
				
				if($j('#TermsAgreement')[0].checked == false)
				{
					errors[errors.length] = 'Please agree to the terms and conditions before submitting your order.';
				}
				else
				{
					$j.cookie('TermsAgreement', 'yes');
				}
			}
			catch(e)
			{
				// No #TermsAgreement
			}
			return errors;
		}
		catch(e)
		{
			handleError('doFullValidation()', e);
		}
		
		return false;
	}
	
	
	
	
	
	
	
	
	
	
	// Complete and handoff the order
	
	function completeOrder()
	{
		try
		{
			var handoffResult = checkoutHandoff(returnOnErrorUrl, "error");
			
			if(handoffResult != null && handoffResult.errors != null)
			{
				if(handoffResult.errors.length > 0)
				{
					displayCartErrors(handoffResult.errors);
				}
				else
				{
					window.location = handoffResult.redirectToUrl;
				}
				
			}
		}
		catch(e)
		{
			handleError('completeOrder()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Add item/items to cart
	
	function addItemsToCart(itemId, theRebate)
	{
		try
		{
			var itemsToAdd = new Array();
			
			$j('[name=ADD]').each(function(){
				itemsToAdd[itemsToAdd.length] = {'itemId': $j(this).val(), 'quantity': 1};
			});
			
			var errors = updateItems(itemsToAdd);
			
			if(errors != null && errors.length > 0)
			{
				displayCartErrors(errors);
			}
		}
		catch(e)
		{
			handleError('addItemsToCart()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Display errors from query string (eg, ?error=Some+Checkout+Error)
	
	function displayQueryErrors()
	{
		try
		{
			var errors = getParameterValues("error");
			
			if(errors != null && errors.length > 0)
			{
				displayCartErrors(errors);
			}		
		}
		catch(e)
		{
			handleError('displayQueryErrors()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Display Cart Errors
	
	function displayCartErrors(errors)
	{
		try
		{
			$j('#FinalizeOrder').removeAttr('class');
			$j('#FinalizeOrder').removeAttr('disabled');
			
			var ErrorsHtml = '<h4>Please correct the following:</h4>';
			$j('.shell').show(250);
			$j('.errors').show(250);
			ErrorsHtml += '<ul>';
			for(i = 0; i < errors.length; i ++)
			{
				ErrorsHtml += '<li>' + String(errors[i]) + '</li>' + '\n';
			}
			ErrorsHtml += '</ul>';
			$j('.errors .content').html(ErrorsHtml);
			showErrorsAnimated($j('.errors'));
			$j('html,body').animate({scrollTop: $j('.errors .content').offset().top - 10}, 1000);
		}
		catch(e)
		{
			handleError('displayCartErrors()', e);
		}
	}
	
	
	
	
	
	
	
	
	// Show errors animated
	
	function showErrorsAnimated()
	{
		try
		{
			$j('.errors').show('fast');
		}
		catch(e)
		{
			handleError('showErrorsAnimated()', e);
		}
	}





}); // Ends Ready Function